// Based on:
//   http://www.theonlytutorials.com/jquery-drum-sets-html5-audio-tag-example/


var hitDrumStartCurrentTime = null;
var hitDrumEndCurrentTime;
var hitDrumMidiPitch;
var hitDrumMidiPitchReadable;

function calcDrumMidiNoteInfo() {
    if (hitDrumStartCurrentTime != null) {

	var hitDrumDuration = hitDrumEndCurrentTime - hitDrumStartCurrentTime;
	
	// console.log("**** " + playedNotePitch + " (midi pitch = " + playedMidiPitch+ ") startTime = ", relativePlayStartTime + ", duration = " + playedDuration);

	if (mediaPlayedNotes[String(mediaStartPlayTime)]) {
	    
	    mediaPlayedNotes[String(mediaStartPlayTime)].push( 
		{ 'type'         : "drum",
		  'midiPitch'    : hitDrumMidiPitch, 
		  //'midiNoteOn'   : relativePlayedNoteStartTime,
		  //'midiNoteOff'  : relativePlayedNoteEndTime,
		  'startCurrentTime' : hitDrumStartCurrentTime,
		  'duration'     : hitDrumDuration,
		  'startPercTime': hitDrumStartCurrentTime/mediaPlayer.duration,
		  'humanReadble' : hitDrumMidiPitchReadable }
	    );
	}
	
    }
}

$(document).ready(function() {
	
    //create the audio tag using jquery
    //include the drum kit mp3s
    
    var base_collection = gs.variables.httpCollection;
    var base_audio = base_collection + "/audio";

    var drum1 = document.createElement('audio');
    drum1.setAttribute('src', base_audio + '/drum1.mp3');
    var drum2 = document.createElement('audio');
    drum2.setAttribute('src', base_audio + '/drum2.mp3');
    var drum3 = document.createElement('audio');
    drum3.setAttribute('src', base_audio + '/drum3.mp3');
    var drum4 = document.createElement('audio');
    drum4.setAttribute('src', base_audio + '/drum4.mp3');
    var drum5 = document.createElement('audio');
    drum5.setAttribute('src', base_audio + '/drum5.mp3');
    var drum6 = document.createElement('audio');
    drum6.setAttribute('src', base_audio + '/drum6.mp3');
    
    var drum;
    
    $('.drum').mousedown(function() {

	hitDrumStartCurrentTime = mediaPlayer.currentTime;
	hitDrumMidiPitchReadable = $(this).attr('id');
	hitDrumMidiPitch = hitDrumMidiPitchReadable.replace(/^drum/,"");
	
	//find the drum hit and play the respective audio
	drum = $(this).attr('id');
	drum = eval(drum);
	
	if (drum.ended) {	    
	    $(this).addClass('hit');
	    drum.play();
	} else {
	    try {
		drum.currentTime = 0;
            } catch (e) {
		console.log("Error thrown when playing drum sound: " + e);
	    }

	    // Force finish of previous drum hit
	    hitDrumEndCurrentTime = mediaPlayer.currentTime;
	    calcDrumMidiNoteInfo();
	    hitDrumStartCurrentTime = mediaPlayer.currentTime;
	    hitDrumEndCurrentTime = null;

	    $(this).addClass('hit');
            drum.play();
        }
    });    

    $('.drum').mouseup(function() {
	hitDrumEndCurrentTime = mediaPlayer.currentTime;
	calcDrumMidiNoteInfo();
	hitDrumStartCurrentTime = null;
	
	$(this).removeClass('hit');
    });

});
